- Qt 5.15
- Qt 3D
- C++ Classes
- QComponent
- Qt 5.15.19 Reference Documentation

# QComponent Class

class Qt3DCore::QComponent

The base class of scene nodes that can be aggregated by Qt3DCore::QEntity instances as a component. More...

Header: | #include <QComponent>
qmake: | QT += 3dcore
Since: | Qt 5.5
Instantiated By: | Component3D
Inherits: | Qt3DCore::QNode

Inherited By:

Qt3DAnimation::QAbstractClipAnimator, Qt3DCore::QArmature, Qt3DCore::QTransform, Qt3DInput::QAxisAccumulator, Qt3DInput::QInputSettings, Qt3DInput::QKeyboardHandler, Qt3DInput::QLogicalDevice, Qt3DInput::QMouseHandler, Qt3DLogic::QFrameAction, Qt3DRender::QAbstractLight, Qt3DRender::QAbstractRayCaster, Qt3DRender::QCameraLens, Qt3DRender::QComputeCommand, Qt3DRender::QEnvironmentLight, Qt3DRender::QGeometryRenderer, Qt3DRender::QLayer, Qt3DRender::QLevelOfDetail, Qt3DRender::QMaterial, Qt3DRender::QObjectPicker, Qt3DRender::QRenderSettings, Qt3DRender::QRenderTarget, Qt3DRender::QSceneLoader, and Qt3DRender::QShaderData

This class was introduced in Qt 5.5.

- List of all members, including inherited members

## Properties

- isShareable : bool

## Public Functions

| QComponent(QNode *parent = nullptr)
QVector<QEntity *> | entities() const
bool | isShareable() const

## Public Slots

void | setShareable(bool isShareable)

## Signals

void | addedToEntity(QEntity *entity)
void | removedFromEntity(QEntity *entity)
void | shareableChanged(bool isShareable)

## Detailed Description

A Qt3DCore::QComponent provides a vertical slice of behavior that can be assigned to and sometimes shared across Qt3DCore::QEntity instances.

Qt3DCore::QComponent subclasses are often aggregated in groups that impart useful behavior to the aggregating entity. For example, to have an Entity that gets drawn by the Qt3D renderer aspect, an entity would most likely aggregate Qt3DCore::QTransform, Qt3DRender::QMesh, and Qt3DRender::QMaterial components.

See also Qt3DCore::QEntity.

## Property Documentation

### isShareable : bool

Holds the shareable flag of the QComponent. The QComponent can be shared across several entities if `true`.

Access functions:

bool | isShareable() const
void | setShareable(bool isShareable)

Notifier signal:

void | shareableChanged(bool isShareable)

## Member Function Documentation

### QComponent::QComponent(QNode *parent = nullptr)

Constructs a new QComponent instance with parent as the parent.

Note: a QComponent should never be instanced directly, instance one of the subclasses instead.

### `[signal]` void QComponent::addedToEntity(QEntity *entity)

Indicates that a reference has been added to entity.

### `[signal]` void QComponent::removedFromEntity(QEntity *entity)

Indicates that a reference has been removed from entity.

### QVector<QEntity *> QComponent::entities() const

Returns a QVector containing all the entities that reference this component.